using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DBAnimTester
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private bool Animating;
		private int Position;
		private Bitmap Frame;
		private Graphics G;
		private SolidBrush B, F;

		private System.Windows.Forms.Button GoStopButton;
		private HHHHControls.DBAnim dbAnim1;
		private System.Windows.Forms.Timer AnimTimer;
		private System.ComponentModel.IContainer components;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			Animating = false;
			Position = 0;
			Frame = new Bitmap(dbAnim1.Width, dbAnim1.Height);
			dbAnim1.Frame = Frame;
			AnimTimer.Tick += new EventHandler(StepFrame);

			G = Graphics.FromImage(Frame);			// we only need to create these once, not in every
			B = new SolidBrush(dbAnim1.BackColor);  // StepFrame() call.
			F = new SolidBrush(dbAnim1.ForeColor);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
				G.Dispose();
				B.Dispose();
				F.Dispose();
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.GoStopButton = new System.Windows.Forms.Button();
			this.dbAnim1 = new HHHHControls.DBAnim();
			this.AnimTimer = new System.Windows.Forms.Timer(this.components);
			this.SuspendLayout();
			// 
			// GoStopButton
			// 
			this.GoStopButton.Location = new System.Drawing.Point(8, 8);
			this.GoStopButton.Name = "GoStopButton";
			this.GoStopButton.TabIndex = 0;
			this.GoStopButton.Text = "Go";
			this.GoStopButton.Click += new System.EventHandler(this.GoStopButton_Click);
			// 
			// dbAnim1
			// 
			this.dbAnim1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.dbAnim1.Frame = null;
			this.dbAnim1.Location = new System.Drawing.Point(88, 8);
			this.dbAnim1.Name = "dbAnim1";
			this.dbAnim1.Size = new System.Drawing.Size(248, 232);
			this.dbAnim1.Style = HHHHControls.DBAnimUnsetStyle.Cross;
			this.dbAnim1.TabIndex = 1;
			this.dbAnim1.Text = "dbAnim1";
			// 
			// AnimTimer
			// 
			this.AnimTimer.Interval = 1;
			this.AnimTimer.Tick += new System.EventHandler(this.StepFrame);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(255)), ((System.Byte)(128)));
			this.ClientSize = new System.Drawing.Size(344, 245);
			this.Controls.Add(this.dbAnim1);
			this.Controls.Add(this.GoStopButton);
			this.ForeColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(128)), ((System.Byte)(255)));
			this.Name = "Form1";
			this.Text = "Form1";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void GoStopButton_Click(object sender, System.EventArgs e)
		{
			if(Animating == false)	// If not animating, turn on animation
			{
				GoStopButton.Text = "Stop";
				AnimTimer.Enabled = true;
				Animating = true;
			} 
			else					// else, turn off animation.
			{
				GoStopButton.Text = "Go";
				AnimTimer.Enabled = false;
				Animating = false;
			}
		}

		// called by AnimTimer's Tick() event.
		private void StepFrame(object sender, EventArgs e) 
		{
			Position += Frame.Width / 100;
			Position %= Frame.Width;
			// Change the Frame:
			G.FillRectangle(B, 0, 0, Frame.Width, Frame.Height);
			G.FillEllipse(F, Position, Frame.Height / 2, 10, 10);
			// show the results:
			dbAnim1.ShowFrame();
		}
	}
}
